/*
 * program: psfilt
 * file: patchlevel.h
 *
 * Copyright  1992 1993 1994 Robert Joop
 *
 * Patch Level
 *
 * $Id: patchlevel.h,v 1.20 1995/03/08 15:40:01 rj Exp $
 * $Log: patchlevel.h,v $
 * Revision 1.20  1995/03/08  15:40:01  rj
 * patchlevel 15:
 * - additional .gz suffix for gzip added.
 * - single quotes (`...') instead of double quotes ("...").
 * - new input type for *roff macro files.
 * - in C(++) mode, translate ``...'' to PS /ellipsis.
 * - fix: one chop() too much for TROFF_SIZE in lex-input.l.
 * - verbmode turned into iso6429verbmode.
 * - ambiguous ISO 646 replaced by ASCII and IA5 (based on a ISO 646 IRV table).
 * - support for ISO 8859-2 thru -10 added.
 * - added: ability to clear and extend the list of meta options (other than thru mangling ~/.psfilt).
 *
 * Revision 1.19  1994/08/19  09:36:40  rj
 * IT_TEXTline mode for mail and news
 *
 * Revision 1.18  1994/08/18  12:15:33  rj
 * new input mode for Tcl scripts.
 * fix for postscript parser font caches that ignore reencoding changes.
 *
 * Revision 1.17  1994/07/16  14:14:29  rj
 * install.sh was missing from autoconf-1.11 if it was reached thru patches...
 *
 * Revision 1.16  1994/07/16  13:36:18  rj
 * refrain from guessing troff translation when the line ends in a backslash
 *
 * Revision 1.15  1994/07/16  12:39:13  rj
 * provisions to use X11R6 PS type 1 fonts
 *
 * Revision 1.14  1994/07/13  18:20:13  rj
 * interrupt-save file generation
 * install forces building of psfilt
 * beta status removed
 *
 * Revision 1.13  1994/07/09  17:34:42  rj
 * input token buffers (especially in mail mode) are no longer in danger of overflowing
 *
 * Revision 1.12  1994/07/09  17:21:52  rj
 * stopping to read at NUL characters stopped
 *
 * Revision 1.11  1994/07/09  17:15:09  rj
 * MEM_C has to be defined before mem.h is included!
 *
 * Revision 1.10  1994/07/09  17:06:44  rj
 * fix for systems where {re,m}alloc() is a macro, not a function
 *
 * Revision 1.9  1994/07/09  16:56:02  rj
 * checking order for gcc and flex reversed
 *
 * Revision 1.8  1994/07/09  16:44:05  rj
 * a lot of const's removed and added
 *
 * Revision 1.7  1994/07/09  15:34:22  rj
 * stuff for configuration via GNU autoconf added
 *
 * Revision 1.6  1994/03/18  12:07:34  rj
 * support for duplex mode added
 * lots of missing `#ifdef COLORED' inserted
 *
 * Revision 1.5  1994/01/09  23:46:02  rj
 * PPD parser fr version 4 PPD files total umgeschrieben.
 * partieller support fr perl.
 *
 * Revision 1.4  1994/01/05  02:36:11  rj
 * fixes fr memory access nach free(); fsopen-linux.c
 *
 * Revision 1.3  1994/01/04  11:56:20  rj
 * minor adjustments
 *
 * Revision 1.2  1994/01/03  13:22:54  rj
 * fix for flex 2.3.7 (unsigned char *yytext) vs. flex 2.4.5 (char *yytext).
 *
 * Revision 1.1.1.1  1993/12/31  20:56:48  rj
 * erster cvs import.
 *
 */

#define PATCHLEVEL	15
